#include <stdio.h>
#include <stdlib.h>
#include "db.h"
#include "modules.h"


void init(void) {
	db_connect();
	read_time();
}


void cleanup(void) {
	db_close();
}


void run_module(char* name, int (*module)(void)) {
	printf("  --> %s\n", name);
	if (!module()) {
		fprintf(stderr, "failure in module '%s'\n", name);
		cleanup();
		exit(2);
	}
	printf("  --< %s\n", name);
}


int main(int argc, char* argv[]) {
	if (argc != 2) {
		printf("usage: %s <database>\n", argv[0]);
		exit(1);
	}
	database = argv[1];
	init();

	/* modules */
	run_module("clock", worldclock);
	run_module("weather", weather);
	run_module("environment", environment);
	/* run_module("market", market); */
	run_module("growth", growth);
	/* run_module("orderexec", orderexec); */

	cleanup();
	return 0;
}
